local link
local loaded = false
local merchantOpen,tradeSkillOpen,auctionOpen,guildBankOpen,saveClickedLink=false,false,false,false,false
local scanningMerchant,scanningTradeSkill,scanningAuction,scanningGuildBank = false,false,false,false
local scanPoint,scanMax,auctionScanStep,auctionScanPoint,guildScanTab,guildScanStep
local scanNew,numScanned,maxScanAttempts,scannedWithoutInspect=_,_,_,false
local secondScan,willScanInspect, targetToScan, numScanAttempts = false,false,_,1
local savedItemIDs
local savedNPCs, currentMerchName, autoScanMerch
--------------------------------------------------------------------------------------Scan trade button
local scanTradeSkillButton = CreateFrame("BUTTON", nil, nil, "UIPanelButtonTemplate")
scanTradeSkillButton:SetWidth(80)
scanTradeSkillButton:SetHeight(18)
scanTradeSkillButton:SetText("Scan")
scanTradeSkillButton:SetFrameStrata("HIGH")
scanTradeSkillButton:SetScript("OnClick", function() 
	saveTradeSkillItems()
end)
scanTradeSkillButton:Hide()
--------------------------------------------------------------------------------------Scan merchant button
local scanMerchantButton = CreateFrame("BUTTON", nil, nil, "UIPanelButtonTemplate")
scanMerchantButton:SetWidth(80)
scanMerchantButton:SetHeight(18)
scanMerchantButton:SetText("Scan")
scanMerchantButton:SetFrameStrata("HIGH")
scanMerchantButton:SetScript("OnClick", function() 
	saveMerchantItems()
end)
scanMerchantButton:Hide()
--------------------------------------------------------------------------------------Scan guild bank button
local scanGuildBankButton = CreateFrame("BUTTON", nil, nil, "UIPanelButtonTemplate")
scanGuildBankButton:SetWidth(80)
scanGuildBankButton:SetHeight(18)
scanGuildBankButton:SetText("Scan")
scanGuildBankButton:SetFrameStrata("HIGH")
scanGuildBankButton:SetScript("OnClick", function() 
	saveGuildBankItems()
end)
scanGuildBankButton:Hide()
--------------------------------------------------------------------------------------Scan auction button
local scanAuctionButton = CreateFrame("BUTTON", nil, nil, "UIPanelButtonTemplate")
scanAuctionButton:SetWidth(80)
scanAuctionButton:SetHeight(18)
scanAuctionButton:SetText("Scan")
scanAuctionButton:SetFrameStrata("HIGH")
scanAuctionButton:SetScript("OnClick", function() 
	saveAuctionItems()
end)
scanAuctionButton:Hide()

--------------------------------------------------------------------------------------Scan target button
local buttonLocked = true
local scanTargetFrame = CreateFrame("Frame", nil, UIParent)
scanTargetFrame:SetSize(84, 30)
local backdrop = {
    bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 12,
    insets = { left = 3, right = 3, top = 3, bottom = 3, },
}
scanTargetFrame:SetScript("OnMouseDown", function()
	scanTargetFrame:StartMoving()
end)
scanTargetFrame:SetScript("OnMouseUp", function()
	scanTargetFrame:StopMovingOrSizing()
end)
scanTargetFrame:SetBackdrop(nil)
scanTargetFrame:SetMovable(false)
scanTargetFrame:EnableMouse(false)
scanTargetFrame:SetAlpha(0)

local scanTargetButton = CreateFrame("BUTTON", nil, scanTargetFrame, "UIPanelButtonTemplate")
scanTargetButton:SetPoint("BOTTOM", 0, 2)
scanTargetButton:SetWidth(80)
scanTargetButton:SetHeight(18)
scanTargetButton:SetText("Scan")
scanTargetButton:SetFrameStrata("LOW")
scanTargetButton:SetScript("OnClick", function()
	if (not scanningTradeSkill and not scanningMerchant and not scanningAuction and not scanningGuildBank) then
		if CanInspect("target") then
			numScanAttempts = 1
			willScanInspect = true
			targetToScan = "target"
			NotifyInspect("target")
			scannedWithoutInspect = true
		end
	end
end)
scanTargetButton:Show()


--------------------------------------------------------------------------------------Progress bar
local scanStatusFrame = CreateFrame("Frame", nil, UIParent)
scanStatusFrame:SetSize(206, 16)
scanStatusFrame:SetPoint("CENTER", UIParent)
scanStatusFrame:SetBackdrop({
    bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 12,
    insets = { left = 3, right = 3, top = 3, bottom = 3, },
})

local scanStatusBar = CreateFrame("StatusBar", nil, scanStatusFrame)
scanStatusBar:SetPoint("TOPLEFT", 3, -3)
scanStatusBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
scanStatusBar:GetStatusBarTexture():SetHorizTile(false)
scanStatusBar:GetStatusBarTexture():SetVertTile(false)
scanStatusBar:SetMinMaxValues(0, 100)
scanStatusBar:SetValue(0)
scanStatusBar:SetWidth(200)
scanStatusBar:SetHeight(10)
scanStatusBar:SetFrameStrata("HIGH")
scanStatusBar:SetStatusBarColor(0,1,0)
scanStatusFrame:Hide()

--------------------------------------------------------------------------------------Inivisible event frame
local linkForgeFrame = CreateFrame("FRAME","LinkForge",UIParent)
linkForgeFrame:SetFrameStrata("BACKGROUND")
linkForgeFrame:SetWidth(2)
linkForgeFrame:SetHeight(2)
linkForgeFrame:SetPoint("BOTTOM", WorldFrame, "BOTTOM", 0, -10)
linkForgeFrame:Show()

linkForgeFrame:RegisterEvent("ADDON_LOADED")
linkForgeFrame:RegisterEvent("PLAYER_LOGOUT")
linkForgeFrame:RegisterEvent("MERCHANT_SHOW")
linkForgeFrame:RegisterEvent("MERCHANT_CLOSED")
linkForgeFrame:RegisterEvent("TRADE_SKILL_SHOW")
linkForgeFrame:RegisterEvent("TRADE_SKILL_CLOSE")
linkForgeFrame:RegisterEvent("AUCTION_HOUSE_SHOW")
linkForgeFrame:RegisterEvent("AUCTION_HOUSE_CLOSED")
linkForgeFrame:RegisterEvent("BANKFRAME_OPENED")
linkForgeFrame:RegisterEvent("GUILDBANKFRAME_OPENED")
linkForgeFrame:RegisterEvent("GUILDBANKFRAME_CLOSED")
linkForgeFrame:RegisterEvent("START_LOOT_ROLL")
linkForgeFrame:RegisterEvent("LOOT_OPENED")
linkForgeFrame:RegisterEvent("QUEST_COMPLETE")
linkForgeFrame:RegisterEvent("QUEST_DETAIL")

------------------------------------------------------------------------------------Chat monitors
local linkForgeChatMonitor = CreateFrame("FRAME","LinkForgeChatMon",UIParent)
linkForgeChatMonitor:SetFrameStrata("BACKGROUND")
linkForgeChatMonitor:SetWidth(2)
linkForgeChatMonitor:SetHeight(2)
linkForgeChatMonitor:SetPoint("BOTTOM", WorldFrame, "BOTTOM", 0, -10)
linkForgeChatMonitor:Show()

linkForgeChatMonitor:RegisterEvent("CHAT_MSG_CHANNEL")
linkForgeChatMonitor:RegisterEvent("CHAT_MSG_BATTLEGROUND")
linkForgeChatMonitor:RegisterEvent("CHAT_MSG_GUILD")
linkForgeChatMonitor:RegisterEvent("CHAT_MSG_OFFICER")
linkForgeChatMonitor:RegisterEvent("CHAT_MSG_PARTY")
linkForgeChatMonitor:RegisterEvent("CHAT_MSG_PARTY_LEADER")
linkForgeChatMonitor:RegisterEvent("CHAT_MSG_RAID")
linkForgeChatMonitor:RegisterEvent("CHAT_MSG_SAY")
linkForgeChatMonitor:RegisterEvent("CHAT_MSG_WHISPER")
linkForgeChatMonitor:RegisterEvent("CHAT_MSG_YELL")

--------------------------------------------------------------------------------------Link replace code
ChatFrame1EditBox:HookScript("OnTextChanged", function()
	local current = ChatFrame1EditBox:GetText()
	while ( current:find("[[", 1, true) and current:find("]]", 1, true) ) do
		local linkBegin,_ = current:find("[[", 1, true)
		local _,linkEnd = current:find("]]", 1, true)
		local linkText = current:sub(linkBegin+2,linkEnd-2)
		if GetItemInfo(linkText) then
			_,link,_,_,_,_,_,_,_,_=GetItemInfo(linkText)
		elseif savedItemIDs[linkText:upper()] then
			link=savedItemIDs[linkText:upper()]
		else
			link = linkText
		end
		local beginText = ""
		if linkBegin > 1 then
			beginText = current:sub(1,linkBegin-1)
		end
		current = beginText..link..current:sub(linkEnd+1)
	end
	while ( current:find("{{", 1, true) and current:find("}}", 1, true) ) do
		local linkBegin,_ = current:find("{{", 1, true)
		local _,linkEnd = current:find("}}", 1, true)
		local itemLink = current:sub(linkBegin+2,linkEnd-2)
		local itemName,_,_,_,_,_,_,_,_,_=GetItemInfo(itemLink)
		if (itemName~=nil and not savedItemIDs[itemName:upper()]) then
			savedItemIDs[itemName:upper()] = itemLink
		end
		local beginText = ""
		if linkBegin > 1 then
			beginText = current:sub(1,linkBegin-1)
		end
		current = beginText..current:sub(linkEnd+1)
	end
	ChatFrame1EditBox:SetText(current)
end)

local function literalize(str)
    return str:gsub("[%(%)%.%%%+%-%*%?%[%]%^%$]", function(c) return "%" .. c end)
end

function saveBagItems()------------------------------------------------------------------------------saveBagItems
	local numSlots,itemLink
	local i=0,j
	repeat
		if not(GetContainerNumSlots(i)==nil)then
			numSlots=GetContainerNumSlots(i)
			j=1;
			repeat
				itemLink=GetContainerItemLink(i,j)
				if itemLink~=nil then     
					local name,_,_,_,_,_,_,_,_,_=GetItemInfo(itemLink)
					if (name~=nil and not savedItemIDs[name:upper()]) then
						savedItemIDs[name:upper()] = itemLink
					end
				end
				j=j+1;
			until(j>numSlots)
		end
		i=i+1;
	until(i>4)
end

function saveBankItems()---------------------------------------------------------------------------saveBankItems()
	local numSlots,itemLink
	local i=-1,j
	local numBags,_ = GetNumBankSlots()+5
	if not(GetContainerNumSlots(i)==nil)then
		numSlots=GetContainerNumSlots(i)
		j=1;
		repeat
			itemLink=GetContainerItemLink(i,j)
			if itemLink~=nil then
				local name,_,_,_,_,_,_,_,_,_=GetItemInfo(itemLink)
				if (name~=nil and not savedItemIDs[name:upper()]) then
					savedItemIDs[name:upper()] = itemLink
				end
			end
			j=j+1;
		until(j>numSlots)
	end
	i = 5
	repeat
		if not(GetContainerNumSlots(i)==nil)then
			numSlots=GetContainerNumSlots(i)
			j=1;
			repeat
				itemLink=GetContainerItemLink(i,j)
				if itemLink~=nil then
					local name,_,_,_,_,_,_,_,_,_=GetItemInfo(itemLink)
					if (name~=nil and not savedItemIDs[name:upper()]) then
						savedItemIDs[name:upper()] = itemLink
					end
				end
				j=j+1;
			until(j>numSlots)
		end
		i=i+1;
	until(i>numBags)
end

function saveEquippedItems(unit)-----------------------------------------------------------------------saveEquippedItems
	scanNew = 0
	numScanned = 0
	local itemLink
	local i=0
	repeat
		itemLink=GetInventoryItemLink(unit,i)
		if itemLink~=nil then
			numScanned=numScanned+1
			local name,_,_,_,_,_,_,_,_,_=GetItemInfo(itemLink)
			if (name~=nil and not savedItemIDs[name:upper()]) then
				savedItemIDs[name:upper()] = itemLink
				scanNew=scanNew+1
			end
		end
		i=i+1
	until(i>19)
	if (unit~="player" and numScanned > 0 and secondScan) then
		ChatFrame1:AddMessage("Scanned "..GetUnitName(unit).."'s "..numScanned.." items. "..scanNew.." new items found.")
	end
end

function saveMerchantItems()-----------------------------------------------------------------------saveMerchantItems
	scanNew = 0
	numScanned=0
	scanMerchantButton:SetText("Stop")
	scanMerchantButton:SetScript("OnClick", function() 
		if scanningMerchant then
			scanningMerchant = false
			ChatFrame1:AddMessage("Scan cancelled at "..numScanned..".")
		end
		scanMerchantButton:SetText("Scan")
		scanMerchantButton:SetScript("OnClick", function() 
			saveMerchantItems()
		end)
	end)
	if (not scanningTradeSkill and not scanningMerchant and not scanningAuction and not scanningGuildBank) then
		for i=1,GetMerchantNumItems() do
			GetMerchantItemLink(i)
		end
		scanPoint = 1
		scanMax = GetMerchantNumItems()
		scanStatusBar:SetMinMaxValues(0,scanMax)
		ChatFrame1:AddMessage("Scanning Merchant items...")
		scanningMerchant = true
	end
end

function saveGuildBankItems()-----------------------------------------------------------------------saveGuildBankItems
	scanNew = 0
	numScanned=0
	scanGuildBankButton:SetText("Stop")
	scanGuildBankButton:SetScript("OnClick", function() 
		if scanningGuildBank then
			scanningGuildBank = false
			ChatFrame1:AddMessage("Scan cancelled at "..numScanned..".")
		end
		scanGuildBankButton:SetText("Scan")
		scanGuildBankButton:SetScript("OnClick", function() 
			saveGuildBankItems()
		end)
	end)
	if (not scanningTradeSkill and not scanningMerchant and not scanningAuction and not scanningGuildBank) then
		scanningGuildBank = true
		scanPoint = 1
		scanMax = 98
		guildScanTab = 1
		guildScanStep = 1
		ChatFrame1:AddMessage("Querying Guild Bank items...")
	end
end


function saveTradeSkillItems()---------------------------------------------------------------------saveTradeSkillItems
	scanNew = 0
	numScanned=0
	scanTradeSkillButton:SetText("Stop")
	scanTradeSkillButton:SetScript("OnClick", function() 
		if scanningTradeSkill then
			scanningTradeSkill = false
			ChatFrame1:AddMessage("Scan cancelled at "..numScanned..".")
		end
		scanTradeSkillButton:SetText("Scan")
		scanTradeSkillButton:SetScript("OnClick", function() 
			saveTradeSkillItems()
		end)
	end)
	if (not scanningTradeSkill and not scanningMerchant and not scanningAuction and not scanningGuildBank) then
		scanPoint = 1
		scanMax = GetNumTradeSkills()
		scanStatusBar:SetMinMaxValues(0,scanMax)
		local skillName,_,_=GetTradeSkillLine()
		ChatFrame1:AddMessage("Scanning "..skillName.." items...")
		scanningTradeSkill = true
	end
end

function saveAuctionItems()---------------------------------------------------------------------saveAuctionItems
	scanNew = 0
	numScanned=0
	scanAuctionButton:SetText("Stop")
	scanAuctionButton:SetScript("OnClick", function() 
		if scanningAuction then
			scanningAuction = false
			ChatFrame1:AddMessage("Scan cancelled at "..numScanned..".")
		end
		scanAuctionButton:SetText("Scan")
		scanAuctionButton:SetScript("OnClick", function() 
			saveAuctionItems()
		end)
	end)
	if (not scanningTradeSkill and not scanningMerchant and not scanningAuction and not scanningGuildBank) then
		scanPoint = 1
		auctionScanPoint = 1
		auctionScanStep = 1
		ChatFrame1:AddMessage("Scanning Auction items...")
		scanningAuction = true
	end
end

function saveLootRollItem(itemID)------------------------------------------------------------------saveLootRollItem
	local itemLink = GetLootRollItemLink(itemID)
	if itemLink~=nil then
		local name,_,_,_,_,_,_,_,_,_=GetItemInfo(itemLink)
		if (name~=nil and not savedItemIDs[name:upper()]) then
			savedItemIDs[name:upper()] = itemLink
		end
	end
end

function saveLootItems()-----------------------------------------------------------------------saveLootItems
	local max = GetNumLootItems()
	for i=1, max do
		local itemLink = GetLootSlotLink(i)
		if itemLink~=nil then
			local name,_,_,_,_,_,_,_,_,_=GetItemInfo(itemLink)
			if (name~=nil and not savedItemIDs[name:upper()]) then
				savedItemIDs[name:upper()] = itemLink
			end
		end
	end
end

function saveQuestRewardItems()
	local itemLink = GetQuestItemLink("reward",1)
	local itemName,_,_,_,_ = GetQuestItemInfo("reward",1)
	if itemName ~= nil then
		if not savedItemIDs[itemName:upper()] then
			savedItemIDs[itemName:upper()] = itemLink
		end
	end
	for i=1,GetNumQuestChoices() do
		local itemLink = GetQuestItemLink("choice",i)
		local itemName,_,_,_,_ = GetQuestItemInfo("choice",i)
		if itemName ~= nil then
			if not savedItemIDs[itemName:upper()] then
				savedItemIDs[itemName:upper()] = itemLink
			end
		end
	end
end


function linkForgeFrame:OnEvent(event, arg1)-----------------------------------------------------------------------------------------------EVENTS
	-----------------------------------------------------------------------------------ADDON_LOADED
	if (event == "ADDON_LOADED" and arg1 == "LinkForge") then
		if SavedItemIDs == nil then
			savedItemIDs = {}
		else
			savedItemIDs = SavedItemIDs
		end
		if SavedNPCs == nil then
			savedNPCs = {}
		else
			savedNPCs = SavedNPCs
		end
		if MaxScanAttempts == nil then
			maxScanAttempts = 5
		else
			maxScanAttempts = MaxScanAttempts
		end
		if ShowButton == nil then
			ShowButton = true
		end
		if (ScanButtonPoint and ScanButtonRelativePoint and ScanButtonXOfs and ScanButtonYOfs) then
			scanTargetFrame:SetPoint(ScanButtonPoint, WorldFrame, ScanButtonRelativePoint, ScanButtonXOfs, ScanButtonYOfs)
		else
			scanTargetFrame:SetPoint("CENTER", WorldFrame, "CENTER", 0, 0)
			ScanButtonPoint = "CENTER"
			ScanButtonRelativePoint = "CENTER"
			ScanButtonXOfs = 0
			ScanButtonYOfs = 0
		end
		ChatFrame1:AddMessage("|cffff0000LinkForge loading...|r")
	-----------------------------------------------------------------------------------MERCHANT_SHOW
	elseif (event == "MERCHANT_SHOW") then
		scanMerchantButton:SetText("Scan")
		scanMerchantButton:SetScript("OnClick", function() 
			saveMerchantItems()
		end)
		merchantOpen = true
		currentMerchName = GetUnitName("target")
		if not savedNPCs[currentMerchName:upper()] then
			saveMerchantItems()
			autoScanMerch = true
		end
		if (ShowButton) then
			scanMerchantButton:Show()
		end
		scanMerchantButton:SetPoint("TOPRIGHT", MerchantFrame, "TOPRIGHT", -58, -15)
		scanStatusFrame:Show()
		scanStatusBar:SetValue(0)
		scanStatusFrame:SetPoint("BOTTOMRIGHT", MerchantFrame, "TOPRIGHT", -58, -15)
	----------------------------------------------------------------------------------MERCHANT_CLOSED
	elseif event == "MERCHANT_CLOSED" then
		LinkForge_LastScan = nil
		merchantOpen = false
		scanMerchantButton:Hide()
		scanStatusFrame:Hide()
		if scanningMerchant then
			scanningMerchant = false
			ChatFrame1:AddMessage("Scan interrupted at "..numScanned..". "..scanNew.." new items found.")
		end
	----------------------------------------------------------------------------------TRADE_SKILL_SHOW
	elseif (event == "TRADE_SKILL_SHOW") then
		scanTradeSkillButton:SetText("Scan")
		scanTradeSkillButton:SetScript("OnClick", function() 
			saveTradeSkillItems()
		end)
		tradeSkillOpen = true
		if (ShowButton) then
			scanTradeSkillButton:Show()
		end
		scanTradeSkillButton:SetPoint("TOPRIGHT", TradeSkillFrame, "TOPRIGHT",-24,-2)
		scanStatusFrame:Show()
		scanStatusBar:SetValue(0)
		scanStatusFrame:SetPoint("BOTTOMRIGHT", TradeSkillFrame, "TOPRIGHT",-24,-2)
	----------------------------------------------------------------------------------TRADE_SKILL_CLOSE
	elseif event == "TRADE_SKILL_CLOSE" then
		LinkForge_LastScan = nil
		tradeSkillOpen = false
		scanTradeSkillButton:Hide()
		scanStatusFrame:Hide()
		if scanningTradeSkill then
			scanningTradeSkill = false
			ChatFrame1:AddMessage("Scan interrupted at "..numScanned..". "..scanNew.." new items found.")
		end
	----------------------------------------------------------------------------------AUCTION_HOUSE_SHOW
	elseif (event == "AUCTION_HOUSE_SHOW") then
		scanAuctionButton:SetText("Scan")
		scanAuctionButton:SetScript("OnClick", function() 
			saveAuctionItems()
		end)
		auctionOpen = true
		if (ShowButton) then
			scanAuctionButton:Show()
		end
		scanAuctionButton:SetPoint("TOPRIGHT", AuctionFrame, "TOPRIGHT", -26, -15)
		scanStatusFrame:Show()
		scanStatusBar:SetValue(0)
		scanStatusFrame:SetPoint("BOTTOMRIGHT", AuctionFrame, "TOPRIGHT", -26, -15)
	----------------------------------------------------------------------------------AUCTION_HOUSE_CLOSED
	elseif event == "AUCTION_HOUSE_CLOSED" then
		LinkForge_LastScan = nil
		auctionOpen = false
		scanAuctionButton:Hide()
		scanStatusFrame:Hide()
		if scanningAuction then
			scanningAuction = false
			ChatFrame1:AddMessage("Scan interrupted at "..numScanned..". "..scanNew.." new items found.")
		end
	----------------------------------------------------------------------------------BANKFRAME_OPENED
	elseif (event == "BANKFRAME_OPENED") then
		saveBankItems()
	----------------------------------------------------------------------------GUILDBANKFRAME_OPENED
	elseif (event == "GUILDBANKFRAME_OPENED") then
		scanGuildBankButton:SetText("Scan")
		scanGuildBankButton:SetScript("OnClick", function() 
			saveGuildBankItems()
		end)
		guildBankOpen = true
		if (ShowButton) then
			scanGuildBankButton:Show()
		end
		scanGuildBankButton:SetPoint("TOPRIGHT", GuildBankFrame, "TOPRIGHT", -25, -15)

		scanStatusFrame:Show()
		scanStatusBar:SetValue(0)
		scanStatusFrame:SetPoint("BOTTOMRIGHT", GuildBankFrame, "TOPRIGHT", -25, -15)
	----------------------------------------------------------------------------GUILDBANKFRAME_CLOSED
	elseif (event == "GUILDBANKFRAME_CLOSED") then
		LinkForge_LastScan = nil
		guildBankOpen = false
		scanGuildBankButton:Hide()
		scanStatusFrame:Hide()
		if scanningGuildBank then
			scanningGuildBank = false
			ChatFrame1:AddMessage("Scan interrupted at "..numScanned..". "..scanNew.." new items found.")
		end
	----------------------------------------------------------------------------------START_LOOT_ROLL
	elseif event == "START_LOOT_ROLL" then
		saveLootRollItem(arg1)
	----------------------------------------------------------------------------------LOOT_OPENED
	elseif event == "LOOT_OPENED" then
		saveLootItems()
	---------------------------------------------------------------------------------QUEST_COMPLETE
	elseif event == "QUEST_COMPLETE" then
		saveQuestRewardItems()
	---------------------------------------------------------------------------------QUEST_DETAIL
	elseif event == "QUEST_DETAIL" then
		saveQuestRewardItems()
	----------------------------------------------------------------------------------PLAYER_LOGOUT
	elseif event == "PLAYER_LOGOUT" then
		SavedItemIDs = savedItemIDs
		SavedNPCs = savedNPCs
		MaxScanAttempts = maxScanAttempts
		ScanButtonPoint,_,ScanButtonRelativePoint,ScanButtonXOfs,ScanButtonYOfs=scanTargetFrame:GetPoint(scanTargetFrame:GetNumPoints())
	end

	if merchantOpen then
		scanMerchantButton:SetPoint("TOPRIGHT", MerchantFrame, "TOPRIGHT", -58, -15)
	end
	if tradeSkillOpen then
		scanTradeSkillButton:SetPoint("TOPRIGHT", TradeSkillFrame, "TOPRIGHT",-24,-2)
	end
	if auctionOpen then
		scanAuctionButton:SetPoint("TOPRIGHT", AuctionFrame, "TOPRIGHT", -26, -15)
	end
	if guildBankOpen then
		scanGuildBankButton:SetPoint("TOPRIGHT", GuildBankFrame, "TOPRIGHT", -25, -15)
	end
end
--------------------------------------------------------------------------------------------------------Function hooks
hooksecurefunc("InspectUnit", function(unit)
	if (not scanningTradeSkill and not scanningMerchant and not scanningAuction and not scanningGuildBank) then
		numScanAttempts=1
		willScanInspect = true
		targetToScan = unit
	end
end)

hooksecurefunc("ChatFrame_OnHyperlinkShow", function(chatFrame, item, itemLink, ...)
	if item:find("item",1,true) then
		link = itemLink
		saveClickedLink = true
	end
end)


function linkForgeChatMonitor:OnEvent(event, msg)--------------------------------------------------------CHAT MESSAGES
	for itemLink in msg:gmatch("|%x+|Hitem:.-|h.-|h|r") do
		local name,_,_,_,_,_,_,_,_,_,_=GetItemInfo(""..itemLink)
		if (name~=nil and not savedItemIDs[name:upper()]) then
			savedItemIDs[name:upper()] = itemLink
		end
	end
end

linkForgeFrame:SetScript("OnEvent", linkForgeFrame.OnEvent);
linkForgeChatMonitor:SetScript("OnEvent", linkForgeChatMonitor.OnEvent);

scanTargetFrame:HookScript("OnUpdate", function()
	if scanTargetFrame:GetAlpha() == 1 then
		if not ShowButton or buttonLocked and (not CanInspect("target") or tradeSkillOpen or merchantOpen or auctionOpen or guildBankOpen) then
			scanTargetFrame:SetAlpha(0)
			scanTargetButton:EnableMouse(false)
		end
	elseif (ShowButton and not tradeSkillOpen and not merchantOpen and not auctionOpen and not guildBankOpen) then
		if CanInspect("target") then
			scanTargetFrame:SetAlpha(1)
			scanTargetButton:EnableMouse(true)
		end
	end
end)

-----------------------------------------------------------------------------------------------------Long/delayed scans
linkForgeFrame:HookScript("OnUpdate", function()
	if (not ShowButton) then
		scanMerchantButton:Hide()
		scanTradeSkillButton:Hide()
		scanAuctionButton:Hide()
		scanGuildBankButton:Hide()
	else
		if merchantOpen then
			scanMerchantButton:Show()
		end
		if tradeSkillOpen then
			scanTradeSkillButton:Show()
		end
		if auctionOpen then
			scanAuctionButton:Show()
		end
		if guildBankOpen then
			scanGuildBankButton:Show()
		end
	end

	if not loaded then
		if (LinkForge_LastScan == nil) then
			LinkForge_LastScan = GetTime()
		end
		if  (GetTime() >= LinkForge_LastScan + 4) then
			saveBagItems()
			saveEquippedItems("player")
			ChatFrame1:AddMessage("|cffff0000LinkForge loaded. Have fun "..GetUnitName("player").."!|r")
			loaded = true
			LinkForge_LastScan = nil
			if not HasRun then
				message("This is the first time running LinkForge. Scanning the Auction House is a good way to start building your item cache. Thanks for downloading LinkForge, enjoy!")
				HasRun = true
			end
		end
	end
	----------------------------------------------------------------------------------Link click delay
	if saveClickedLink then
		if (LinkForge_LastScan == nil) then
			LinkForge_LastScan = GetTime()
		end
		if (GetTime() >= LinkForge_LastScan + 0.2) then
			LinkForge_LastScan = nil
			local name,_,_,_,_,_,_,_,_,_,_=GetItemInfo(""..link)
			if (name~=nil and not savedItemIDs[name:upper()]) then
				savedItemIDs[name:upper()] = link
			end
			saveClickedLink = false
		end
	end
	----------------------------------------------------------------------------------Inspect delay
	if willScanInspect then
		if (LinkForge_LastScan == nil) then
			LinkForge_LastScan = GetTime()
		end
		if (GetTime() >= LinkForge_LastScan + 0.5) then
			LinkForge_LastScan = GetTime()
			if GetUnitName(targetToScan) then
				saveEquippedItems(targetToScan)
				if (numScanned == 0 and numScanAttempts < maxScanAttempts) then
					numScanAttempts=numScanAttempts+1
				else
					if numScanned == 0 then
						ChatFrame1:AddMessage("Failed to scan "..GetUnitName(targetToScan).."'s items.")
					end
					if secondScan then
						willScanInspect = false
						targetToScan = nil
						LinkForge_LastScan = nil
						secondScan = false
						if scannedWithoutInspect then
							ClearInspectPlayer()
							scannedWithoutInspect = false
						end
					else
						secondScan = true
					end
				end
			else
				ChatFrame1:AddMessage("Failed to scan. Don't change targets before scan completes.")
				willScanInspect = false
				targetToScan = nil
				LinkForge_LastScan = nil
				if scannedWithoutInspect then
					ClearInspectPlayer()
					scannedWithoutInspect = false
				end
			end
		end
	end
	--------------------------------------------------------------------------------------Merchant loop
	if scanningMerchant then
		if (LinkForge_LastScan == nil) then
			LinkForge_LastScan = GetTime()
		end
		if autoScanMerch then
			if (GetTime() >= LinkForge_LastScan + 1) then
				LinkForge_LastScan = GetTime()
				autoScanMerch = false
			end			
		else
			if (GetTime() >= LinkForge_LastScan + 0.05) then
				LinkForge_LastScan = GetTime()
				local itemLink
				if scanPoint%10 == 0 then
					scanMax = GetMerchantNumItems()
					scanStatusBar:SetMinMaxValues(0,scanMax)
				end
				if scanPoint<=scanMax then
					itemLink = GetMerchantItemLink(scanPoint)
					if itemLink~=nil then
						numScanned=numScanned+1
						local name,_,_,_,_,_,_,_,_,_=GetItemInfo(""..itemLink)
						if (name~=nil and not savedItemIDs[name:upper()]) then
							savedItemIDs[name:upper()] = itemLink
							scanNew=scanNew+1
						end
					end
					scanPoint=scanPoint+1
					scanStatusBar:SetValue(scanPoint)
				else
					scanningMerchant = false
					ChatFrame1:AddMessage("Completed scan of "..numScanned.." Merchant items. "..scanNew.." new items found.")
					if not savedNPCs[currentMerchName:upper()] then
						savedNPCs[currentMerchName:upper()] = "scanned"
					end
					scanMerchantButton:SetText("Scan")
					scanMerchantButton:SetScript("OnClick", function() 
						saveMerchantItems()
					end)
					LinkForge_LastScan = nil
				end
			end
		end
	end
	--------------------------------------------------------------------------------------Guild bank loop
	if scanningGuildBank then
		if guildScanStep == 1 then
			if (LinkForge_LastScan == nil) then
				LinkForge_LastScan = GetTime()
			end
			if (GetTime() >= LinkForge_LastScan + 1) then
				LinkForge_LastScan = GetTime()
				if (guildScanTab<=GetNumGuildBankTabs()) then
					RunScript("QueryGuildBankTab("..guildScanTab..")")
					guildScanTab=guildScanTab+1
					local viewable,_,_,_=GetGuildBankTabPermissions(guildScanTab)
					while (not viewable and guildScanTab <= GetNumGuildBankTabs()) do
						guildScanTab=guildScanTab+1
						viewable,_,_,_=GetGuildBankTabPermissions(guildScanTab)
					end
				else
					GuildBankTab1Button:Click()
					scanStatusBar:SetMinMaxValues(0,scanMax*GetNumGuildBankTabs())
					guildScanTab=1
					guildScanStep=2
					ChatFrame1:AddMessage("Scanning Guild Bank items...")
				end
			end
		else
			if (LinkForge_LastScan == nil) then
				LinkForge_LastScan = GetTime()
			end
			if (GetTime() >= LinkForge_LastScan + 0.05) then
				LinkForge_LastScan = GetTime()
				local itemLink
				if scanPoint<=scanMax then
					itemLink = GetGuildBankItemLink(guildScanTab, scanPoint)
					if itemLink~=nil then
						numScanned=numScanned+1
						local name,_,_,_,_,_,_,_,_,_=GetItemInfo(""..itemLink)
						if (name~=nil and not savedItemIDs[name:upper()]) then
							savedItemIDs[name:upper()] = itemLink
							scanNew=scanNew+1
						end
					end
					scanPoint=scanPoint+1
					scanStatusBar:SetValue(scanPoint+(scanMax*(guildScanTab-1)))
				else
					guildScanTab=guildScanTab+1
					local viewable,_,_,_=GetGuildBankTabPermissions(guildScanTab)
					while (not viewable and guildScanTab <= GetNumGuildBankTabs()) do
						guildScanTab=guildScanTab+1
						viewable,_,_,_=GetGuildBankTabPermissions(guildScanTab)
					end
					if guildScanTab<=GetNumGuildBankTabs() then
						scanPoint=1
						scanStatusBar:SetMinMaxValues(0,scanMax*GetNumGuildBankTabs())
					else
						scanStatusBar:SetValue(scanPoint+(scanMax*(guildScanTab-1)))
						scanningGuildBank = false
						ChatFrame1:AddMessage("Completed scan of "..numScanned.." Guild Bank items. "..scanNew.." new items found.")
						scanGuildBankButton:SetText("Scan")
						scanGuildBankButton:SetScript("OnClick", function() 
							saveGuildBankItems()
						end)
						LinkForge_LastScan = nil
					end
				end
			end
		end
	end
	--------------------------------------------------------------------------------------Trade skill loop
	if scanningTradeSkill then
		if (LinkForge_LastScan == nil) then
			LinkForge_LastScan = GetTime()
		end
		if (GetTime() >= LinkForge_LastScan + 0.05) then
			LinkForge_LastScan = GetTime()
			local itemLink
			if scanPoint%10 == 0 then
				scanMax = GetNumTradeSkills()
				scanStatusBar:SetMinMaxValues(0,scanMax)
			end
			if scanPoint<=scanMax then
				itemLink = GetTradeSkillItemLink(scanPoint)
				if itemLink~=nil then
					numScanned=numScanned+1
					local name,_,_,_,_,_,_,_,_,_=GetItemInfo(""..itemLink)
					if (name~=nil and not savedItemIDs[name:upper()]) then
						savedItemIDs[name:upper()] = itemLink
						scanNew=scanNew+1
					end
					num = GetTradeSkillNumReagents(scanPoint)
					local id = 1
					repeat
						itemLink = GetTradeSkillReagentItemLink(scanPoint,id)
						if itemLink~=nil then
							numScanned=numScanned+1
							local name,_,_,_,_,_,_,_,_,_=GetItemInfo(""..itemLink)
							if (name~=nil and not savedItemIDs[name:upper()]) then
								savedItemIDs[name:upper()] = itemLink
								scanNew=scanNew+1
							end
						end
						id=id+1
					until(id>num)
				end
				scanPoint=scanPoint+1
				scanStatusBar:SetValue(scanPoint)
			else
				scanningTradeSkill = false
				local skillName,_,_=GetTradeSkillLine()
				ChatFrame1:AddMessage("Completed scan of "..numScanned.." "..skillName.." items. "..scanNew.." new items found.")
				scanTradeSkillButton:SetText("Scan")
				scanTradeSkillButton:SetScript("OnClick", function() 
					saveTradeSkillItems()
				end)
				LinkForge_LastScan = nil
			end
		end
	end
	--------------------------------------------------------------------------------------Auction loop
	if scanningAuction then
		if (LinkForge_LastScan == nil) then
			LinkForge_LastScan = GetTime()
		end
		if auctionScanStep == 1 then
			if (GetTime() >= LinkForge_LastScan + 1) then
				LinkForge_LastScan = GetTime()
				SortAuctionSetSort("list","name")
				auctionScanStep=2
			end
		elseif auctionScanStep == 2 then
			if (GetTime() >= LinkForge_LastScan + 1) then
				LinkForge_LastScan = GetTime()
				QueryAuctionItems()
				auctionScanStep=3
			end
		elseif auctionScanStep == 3 then
			if (GetTime() >= LinkForge_LastScan + 2) then
				LinkForge_LastScan = GetTime()
				auctionScanStep=4
			end
		elseif auctionScanStep == 4 then
			if (GetTime() >= LinkForge_LastScan + 0.05) then
				LinkForge_LastScan = GetTime()
				local itemLink
				local loopLength
				loopLength,scanMax = GetNumAuctionItems("list")
				scanStatusBar:SetMinMaxValues(0,scanMax)
				if scanPoint<=scanMax then
					if auctionScanPoint<=loopLength then
						itemLink = GetAuctionItemLink("list",auctionScanPoint)
						local name,_,_,_,_,_,_,_,_,_,_,_,_=GetAuctionItemInfo("list", auctionScanPoint);
						if itemLink~=nil then
						numScanned=numScanned+1
							if (name~=nil and not savedItemIDs[name:upper()]) then
								savedItemIDs[name:upper()] = itemLink
								scanNew=scanNew+1
							end
						end
						scanPoint=scanPoint+1
						scanStatusBar:SetValue(scanPoint)
						auctionScanPoint=auctionScanPoint+1
					else
						BrowseNextPageButton:Click()
						auctionScanPoint=1
						auctionScanStep = 5
					end
				else
					scanningAuction = false
					ChatFrame1:AddMessage("Completed scan of "..numScanned.." Auction items. "..scanNew.." new items found.")
					scanAuctionButton:SetText("Scan")
					scanAuctionButton:SetScript("OnClick", function() 
						saveAuctionItems()
					end)
					LinkForge_LastScan = nil
				end
			end
		elseif auctionScanStep == 5 then
			if (GetTime() >= LinkForge_LastScan + 0.4) then
				LinkForge_LastScan = GetTime()
				auctionScanStep=4
			end
		end
	end
end)

--------------------------------------------------------------------------------------Slash commands/handler
SLASH_LINKFORGE1 = "/lf"
SLASH_LINKFORGE2 = "/linkforge"

local function lfHandler(str)
	local switch, msg = str:match("([^ ]+) (.*)")
	if (str == "scan") then
		if tradeSkillOpen then
			saveTradeSkillItems()
		elseif merchantOpen then
			saveMerchantItems()
		elseif auctionOpen then
			saveAuctionItems()
		elseif guildBankOpen then
			saveGuildBankItems()
		elseif CanInspect("target") then
			numScanAttempts = 1
			willScanInspect = true
			targetToScan = "target"
			NotifyInspect("target")
			scannedWithoutInspect = true
		else
			RunScript("UIErrorsFrame:AddMessage(\"Nothing to scan\", 1.0, 0.0, 0.0, 53, 5)")
		end
	elseif (str == "setmaxscans") then
		ChatFrame1:AddMessage("/lf setmaxscans # - sets the max number of attempts to scan players gear (scanning doesn't always work on first try)")
	elseif (switch == "setmaxscans") then
		local numPoint = msg:find("%d")
		local numText = msg:sub(numPoint,numPoint)
		local num = tonumber(numText)
		if num > 0 then
			maxScanAttempts = num
			ChatFrame1:AddMessage("Set max scans to "..maxScanAttempts)
		end
	elseif (switch == "button" and msg == "lock") then
		buttonLocked = true
		scanTargetFrame:SetBackdrop(nil)
		scanTargetFrame:SetMovable(false)
		scanTargetFrame:EnableMouse(false)
	elseif (switch == "button" and msg == "unlock") then
		buttonLocked = false
		scanTargetFrame:SetAlpha(1)
		scanTargetFrame:SetBackdrop(backdrop)
		scanTargetFrame:SetMovable(true)
		scanTargetFrame:EnableMouse(true)
		ScanButtonPoint,_,ScanButtonRelativePoint,ScanButtonXOfs,ScanButtonYOfs=scanTargetFrame:GetPoint(scanTargetFrame:GetNumPoints())
	elseif (switch == "button" and msg == "hide") then
		ShowButton = false
		ChatFrame1:AddMessage("Scan buttons will no longer be shown")
	elseif (switch == "button" and msg == "show") then
		ShowButton = true
		ChatFrame1:AddMessage("Scan buttons will now be shown")
	elseif (str == "count") then
		local count = 0
		for k,v in pairs(savedItemIDs) do
			count=count+1
		end
		ChatFrame1:AddMessage("Cache contains "..count.." items.")
	else
		ChatFrame1:AddMessage("LinkForge: Type [[Item Name]] to create a real link in chat. Only works on items you've seen before (blame Blizzard, not me)")
		ChatFrame1:AddMessage("Commands:")
		ChatFrame1:AddMessage("/lf scan - scans auction/merchant/target/etc (used if another addon messes up scan button display)")
		ChatFrame1:AddMessage("/lf setmaxscans # - sets the max number of attempts to scan players gear (scanning doesn't always work on first try)")
		ChatFrame1:AddMessage("/lf button [lock/unlock] - allows movement of target scan button")
		ChatFrame1:AddMessage("/lf button [show/hide] - toggle displaying of scan buttons")
	end
end

SlashCmdList["LINKFORGE"] = lfHandler













